package calc;

import java.io.InputStream;


class Parser(in:InputStream) extends Scanner(in)  {
  // note: ce code utilise les memes fichiers `Scanner.java' et `Tokens.java'
  //        que la solution en java.
  //        c'est pour ca qu'on ecrit `nextToken()' au lieu de `nextToken'.

  import Tokens._;

  // initialization
  nextToken();

  def expression: Unit = {
    term;
    while (token == PLUS || token == MINUS ) {
      nextToken();
      term;
    }
  }

  def term: Unit = {
    factor;
    while (token == MUL || token == DIV) {
      nextToken();
      factor;
    }
  }

  def factor: Unit = {
    token match {
      case LITERAL => 
        nextToken();
      case LPAREN => 
        nextToken();
        expression;
        if (token == RPAREN)
          nextToken();
        else
          error("')' expected");
      case _ =>
        error("illegal start of expression");
    }
  }
}
