// en Scala
package calc;

abstract class Expr {
  /** position pour signaler les erreurs, presente dans tous les noeuds. */
  def pos: Int;
}
/** sous-classe pour representer les nombres */
case class IntLit(pos: int, value: int) extends Expr {}
// le champ "pos" de IntLit definit automatiquement la methode "pos" de Expr.

/** sous-classe pour representer les operations */
case class BinOp(pos: Int, op: Int, left: Expr, right: Expr) extends Expr {}
