//
// un visiteur qui evalue
//

package calc;
import calc.Expr.* ;

public class Eval implements Expr.Visitor {
    int result;
    public void caseIntLit(IntLit expr) {
        result = expr.value;
    }
    public void caseBinOp(BinOp expr) {
        int l = visit(expr.left);
        int r = visit(expr.right);
        switch(expr.operator) {
        case Scanner.PLUS:  result = l+r; break;
        case Scanner.MINUS: result = l-r; break;
        case Scanner.MUL:   result = l*r; break;
        case Scanner.DIV:   result = l/r; break;
        default: throw new InternalError();
        }
    }
        
    public static int visit(Expr tree) {
        Eval v = new Eval();
        tree.apply(v);
        return v.result;
    }
}
