//
// un visiteur toString
//
package calc;

import calc.Expr.* ;

public class ToString implements Expr.Visitor {
    String result;
    public void caseIntLit(IntLit expr) {
        result = String.valueOf(expr.value);
    }
    public void caseBinOp(BinOp expr) {
        result = "("
            +visit(expr.left)
            +Scanner.representation(expr.operator)
            +visit(expr.right)+")";
    }
    
    public static String visit(Expr tree) {
        ToString v = new ToString();
        tree.apply(v);
        return v.result;
    }
}
